c------------------------------------------------------------------------------

      subroutine lha_file(imode)

      implicit double precision (a-h,o-z)
      implicit integer (i-n)

      include 'global.inc'
      include 'lha.inc'
      include 'scales.inc'

      integer imode
      integer i1,i11,istop

      character*50 procfile
      character*7 istr 
      character*100 line
      logical doprint
      procfile = "procinfo.dat"

      if(imode.eq.-1) then    
         open(31,file='sample.evnt',form='unformatted')
         open(32,file='sample.info')
      elseif(imode.eq.0) then
c...finding the maximal weight 
         close(31)
         open(31,file='sample.evnt',form='unformatted')
         istop=1
         wtmax=0d0
         do while(istop.eq.1)
            read(31,end=200) nup,idprup,xwgtup,scalup,aqedup,aqcdup
            do i1=1,nup
               read(31),idup(i1),istup(i1),mothup(1,i1),
     &              mothup(2,i1),icolup(1,i1),icolup(2,i1), 
     &              pup(1,i1),pup(2,i1),pup(3,i1),pup(4,i1),
     &              pup(5,i1),vtimup(i1),spinup(i1)
            enddo   

            if(xwgtup.gt.wtmax) wtmax=xwgtup
         enddo
 200     continue
         close(31)
         open(32,file='sample.info')
c... PDG codes of the two incoming beam particles
         idbmup(1)=2212*sign1      
         idbmup(2)=2212*sign2
c...energies in Gev of two incoming beam particles
         ebmup(1)=ecm/2          
         ebmup(2)=ecm/2
c...number of different external processes        
         nprup=1 
c...master switch dictaiting for events weights and cross sections
c...maximum event weight
         if(unweighting)then
            idwtup=3 
            xmaxup(1)=1d0
         endif
         if(.not.unweighting)then
             idwtup=2
             xmaxup(1)=wtmax !/1000
         endif
c...integer identifier of each external process           
         lprup(1)=procID  
c...not t o clash with pdflib
         pdfgup(1)=0
         pdfgup(2)=0
c...CTEQ6L1 LHA (LHAGLUE)                                                     
         pdfsup(1)=10042
         pdfsup(2)=10042
c...cross section for each external process in pb
         xsecup(1)=xsection/1000
c...statistical error on the cross section in pb
         xerrup(1)=sdev/1000
         write(32,5100)idbmup(1),idbmup(2),ebmup(1),ebmup(2),
     &        pdfgup(1),pdfgup(2),pdfsup(1),pdfsup(2),idwtup,nprup
         write(32,5200)xsecup(1),xerrup(1),xmaxup(1),lprup(1)         
c         close(31)
         close(32)
      elseif(imode.eq.1) then
         open(31,file='sample.evnt',form='unformatted')
         open(32,file='sample.info')
         open(33,file='sample_evnt_vbfnlo.lhe')
         write(33,'(A)') '<LesHouchesEvents version="1.0">'
         write(33,'(A)') '<!--'
         write(33,'(A)') 
     &   'File generated with VBFNLO - parton level MC program (LO)' 
         
         doprint = .false.
c...open procinfo file
         open (unit=55,
     &        file=procfile,
     &        status='old',err=77)     
         
         write (istr,'(a2,I4.4)') "##",procid
 50      continue
         read(55,'(a100)',end=99,err=99) line    
         if (index(line,"##").ne.0) doprint = .false.
         if (index(line,istr).ne.0) then 
            doprint = .true.
            goto 50
         endif
         if (doprint) write(33,'(A)') line
         goto 50
 99      continue      
         close(55)
 77      continue

         write(33,'(A)') '-->'
         write(33,'(A)') '<init>'
         read(32,*)idbmup(1),idbmup(2),ebmup(1),ebmup(2),
     &        pdfgup(1),pdfgup(2),pdfsup(1),pdfsup(2),idwtup,nprup
         read(32,*)xsecup(1),xerrup(1),xmaxup(1),lprup(1)         
         write(33,5100)idbmup(1),idbmup(2),ebmup(1),ebmup(2),
     &        pdfgup(1),pdfgup(2),pdfsup(1),pdfsup(2),idwtup,nprup
         write(33,5200)xsecup(1),xerrup(1),xmaxup(1),lprup(1)
         write(33,'(A)') '</init>'
         istop=1
         do while(istop.eq.1) 
            nevall=nevall+1
            read(31,end=100) nup,idprup,xwgtup,scalup,aqedup,aqcdup
            do i1=1,nup
               read(31),idup(i1),istup(i1),mothup(1,i1),
     &              mothup(2,i1),icolup(1,i1),icolup(2,i1), 
     &              pup(1,i1),pup(2,i1),pup(3,i1),pup(4,i1),
     &              pup(5,i1),vtimup(i1),spinup(i1)
            enddo
            if(unweighting)then
               rn=RandomNumber()
               if(rn*wtmax.lt.xwgtup) then ! event is to be kept
                  nevacc=nevacc+1
                  xwgtup=1d0
                  write(33,'(A)') '<event>'
                  write(33,5300)nup,idprup,xwgtup,scalup,aqedup,aqcdup
                  do i1=1,nup
                     write(33,5400),idup(i1),istup(i1),mothup(1,i1),
     &                    mothup(2,i1),icolup(1,i1),icolup(2,i1), 
     &                    pup(1,i1),pup(2,i1),pup(3,i1),pup(4,i1),
     &                    pup(5,i1),vtimup(i1),spinup(i1)
                  enddo   
                  write(33,'(A)') '</event>'
               endif
            else
               write(33,'(A)') '<event>'
               write(33,5300)nup,idprup,xwgtup,scalup,aqedup,aqcdup
               do i1=1,nup
                  write(33,5400),idup(i1),istup(i1),mothup(1,i1),
     &                 mothup(2,i1),icolup(1,i1),icolup(2,i1), 
     &                 pup(1,i1),pup(2,i1),pup(3,i1),pup(4,i1),
     &                 pup(5,i1),vtimup(i1),spinup(i1)
               enddo   
               write(33,'(A)') '</event>'               
            endif
         enddo
 100     continue
         nevall=nevall-1
         write(33,'(A)') '</LesHouchesEvents>'
         close(31,status='delete')
         close(32,status='delete') 
      endif
 5100 format(1p,2i8,2e14.6,6i6)
 5200 format(1p,3e14.6,i6)
 5300 format(1p,2i6,4e14.6)
 5400 format(1p,i8,5i5,5e18.10,e9.1,e9.1)  
      end

c------------------------------------------------------------------------------

      subroutine lha_put(p,v)

      implicit double precision (a-h,o-z)
      implicit integer (i-n)

      include 'global.inc'
      include 'lha.inc'
      include 'scales.inc'

      integer iput,gnlo  
      integer i1,i11,istop,i2
      integer idflav(4),listposition
      double precision alphas5,pinv1,pinv2
      double precision p(0:3,max_p,max_ptilde)
      double precision v(0:3,max_v,max_vtilde)
      double precision vv(4),pp1(4),pp2(4),ncms1(3),ncms2(3)
      double precision lpp1, lpp2, s, mtau, pp, rn
      double precision  alfas, xmt, alfa, xmz, xmw, sin2w, xmh
      common /bkopin/   alfas, xmt, alfa, xmz, xmw, sin2w, xmh

      data mtau /1.77699d0/

 
      if(doNLO)then
         gnlo=1
      else
         gnlo=0
      endif
c...number of particle entries in the current parton level event 
      nup=lnup(iprocess)
c...identity of the current process
      idprup=procID
c...event weight
      xwgtup=eventweight        !/1000
c...scale Q of event
      scalup=max((sqrt(mufsq(1,1))),(sqrt(mufsq(2,1))))  
c...QED coupling
      aqedup=alfa
c...QCD coupling
      aqcdup=alphas5(scalup**2,gnlo)
c...write the information to the sample.evnt file
      write(31)nup,idprup,xwgtup,scalup,aqedup,aqcdup
c...number of boson(s)
      n_b=n_v/2
c------------------------------------
c...Quarks & gluon
c------------------------------------

      do i1=1,n_p 
c...particle identity code as in PDG               
         idup(i1)=lidup(i1,iprocess)
c...status code of particle (=-1 incoming particle =1 outgoing)
         istup(i1)=listup(i1,iprocess)
c...momenta of partons     
         pup(1,i1)=p(1,i1,1)
         pup(2,i1)=p(2,i1,1)
         pup(3,i1)=p(3,i1,1)
         pup(4,i1)=p(0,i1,1)
         pup(5,i1)=0d0
c...orgin information
         mothup(1,i1)=lmothup(1,i1,iprocess)
         mothup(2,i1)=lmothup(2,i1,iprocess)
c...colour information
         icolup(1,i1)=licolup(1,i1,iprocess)
         icolup(2,i1)=licolup(2,i1,iprocess)
c...secondary vertex information (invariant lifetime)
         vtimup(i1)=0d0
c...spin information
         spinup(i1)=9d0
      enddo
c...particle identity code for vector boson decay products as in PDG 


c------------------------------------
c...Decay products of vector bosons
c------------------------------------

      call fillColorless(idflav,listposition)

      do i1=1,n_v
         i11=n_p+n_b+i1
c...particle identity code
         idup(i11)=lidup(i11,1)
c...status code of particle (=-1 incoming particle =1 outgoing)
         istup(i11)=listup(i11,1)
c...colour information
         icolup(1,i11)=licolup(1,i11,1)
         icolup(2,i11)=licolup(2,i11,1)
c...orgin information
         mothup(1,i11)=lmothup(1,i11,1)
         mothup(2,i11)=lmothup(2,i11,1)
c...life time and spin information
         vtimup(i11)=0d0
         spinup(i11)=helicity(i1)
c...momenta of vector boson(s) decay products
         pup(1,i11)=v(1,i1,1)
         pup(2,i11)=v(2,i1,1)
         pup(3,i11)=v(3,i1,1)
         pup(4,i11)=v(0,i1,1)
         pup(5,i11)=0d0
         if(taumass) then
            if(abs(idflav(i1)).eq.15) pup(5,i11)=mtau
         endif
      enddo  

c...helicity configurations for some processes (decay of Higgs boson only)
      select case(procID)
      case(2101,2104,101,104)
         do i1=1,n_v
            i11=n_p+n_b+i1
            spinup(i11)=9d0
         enddo
      case(2102:2103,102:103,2141:2143,141:143)
         do i1=1,n_v,2
            i11=n_p+n_b+i1
            rn=RandomNumber()
            if (rn.gt.0.5d0) then
               spinup(i11)=1
               spinup(i11+1)=-spinup(i11)
            else
               spinup(i11)=-1
               spinup(i11+1)=-spinup(i11)
            endif
         enddo
      case(144:146,2144:2146)
         do i1=1,n_v/2
            rn=RandomNumber()
            if (rn.gt.0.5d0) then
               spinup(n_p+n_b+1)= 1
               spinup(n_p+n_b+2)=-1
            else
               spinup(n_p+n_b+1)=-1
               spinup(n_p+n_b+2)= 1
            endif
            spinup(n_p+n_b+3)= 1 !nubar
            spinup(n_p+n_b+4)=-1 !nu            
         enddo
      case(2111:2119,111:119) 
         spinup(n_p+n_b+1)=-1   !nu
         spinup(n_p+n_b+2)= 1   !l+
         spinup(n_p+n_b+3)= 1   !nubar
         spinup(n_p+n_b+4)=-1   !l-
      case(2204,204)
         spinup(n_p+n_b+1)= 1   !nubar
         spinup(n_p+n_b+2)=-1   !nu    
      case(2504:2506,504:506)
         spinup(n_p+n_b+3)= 1   !nubar
         spinup(n_p+n_b+4)=-1   !nu             
      end select

c...mass effects for tau leptons
      if(taumass)then
      do i1=1,n_v
         select case(procID)
         case(2103,2501:2506,501:506,2203,203,2141:2146,141:146,103) ! ZZ case
           if(idflav(i1).eq.-15) then
               do i2=1,3
                  pp1(i2)=v(i2,i1,1)   !tau+
                  pp2(i2)=v(i2,i1+1,1) !tau-
               enddo
               pp1(4)=v(0,i1,1)
               pp2(4)=v(0,i1+1,1)
               do i2=1,4
                  vv(i2)=pp1(i2)+pp2(i2)
               enddo

               call bostdq(1,vv,pp1,pp1)
               call bostdq(1,vv,pp2,pp2)

               lpp1=dsqrt(pp1(1)**2+pp1(2)**2+pp1(3)**2)
               lpp2=dsqrt(pp2(1)**2+pp2(2)**2+pp2(3)**2)

               do i2=1,3
                  ncms1(i2)=pp1(i2)/lpp1
                  ncms2(i2)=pp2(i2)/lpp2
               enddo

               pp=dsqrt(pp1(4)**2-mtau**2)
               do i2=1,3
                  pp1(i2)=pp*ncms1(i2)
                  pp2(i2)=pp*ncms2(i2)
               enddo

               call bostdq(-1,vv,pp1,pp1)
               call bostdq(-1,vv,pp2,pp2)

               do i2=1,4
                  pup(i2,n_p+n_b+i1)=pp1(i2)
               enddo
               do i2=1,4
                  pup(i2,n_p+n_b+i1+1)=pp2(i2)
               enddo
            endif
         case(2411:2419,411:419,2303,303,2306,306,2111:2119,111:119) !WW case
            if(abs(idflav(i1)).eq.15) then
               do i2=1,3
                  pp1(i2)=v(i2,i1,1) ! tau+ or tau-
                  pp2(i2)=v(i2,i1-1,1) ! nu_tau or nu_tau~
               enddo
               pp1(4)=v(0,i1,1)
               pp2(4)=v(0,i1-1,1)

               do i2=1,4
                  vv(i2)=pp1(i2)+pp2(i2)
               enddo

               pinv=dsqrt(vv(4)**2-vv(1)**2-vv(2)**2-vv(3)**2)

               call bostdq(1,vv,pp1,pp1)
               call bostdq(1,vv,pp2,pp2)
               lpp1=dsqrt(pp1(1)**2+pp1(2)**2+pp1(3)**2)
               lpp2=dsqrt(pp2(1)**2+pp2(2)**2+pp2(3)**2)

               do i2=1,3
                  ncms1(i2)=pp1(i2)/lpp1
                  ncms2(i2)=pp2(i2)/lpp2
               enddo

               pp1(4)=(pinv**2+mtau**2)/(2d0*pinv)
               pp2(4)=(pinv**2-mtau**2)/(2d0*pinv)

               pp=dsqrt(pp1(4)**2-mtau**2)            

               do i2=1,3
                  pp1(i2)=pp*ncms1(i2)
                  pp2(i2)=pp2(4)*ncms2(i2)
               enddo 

               call bostdq(-1,vv,pp1,pp1)
               call bostdq(-1,vv,pp2,pp2)

               do i2=1,4
                  pup(i2,n_p+n_b+i1)=pp1(i2)
               enddo
               do i2=1,4
                  pup(i2,n_p+n_b+i1-1)=pp2(i2)
               enddo
            endif
         end select
      enddo           
      endif

c------------------------------------
c...Vector bosons
c------------------------------------

c...life time and spin information
      do i1=1,n_b
         i11=n_p+i1
c...particle identity code
         idup(i11)=lidup(i11,1)
c...status code of particle (=-1 incoming particle =1 outgoing)
         istup(i11)=listup(i11,1)
c...colour information
         icolup(1,i11)=licolup(1,i11,1)
         icolup(2,i11)=licolup(2,i11,1)
c...orgin information
         mothup(1,i11)=lmothup(1,i11,1)
         mothup(2,i11)=lmothup(2,i11,1)
         vtimup(i11)=0d0
         spinup(i11)=9d0
      enddo
      iput=0
      do i1=1,n_b*2,2
         iput=iput+1
         i11=n_p+iput
c...momenta of vector boson(s)
         pup(1,i11)=v(1,i1,1)+v(1,i1+1,1)
         pup(2,i11)=v(2,i1,1)+v(2,i1+1,1)
         pup(3,i11)=v(3,i1,1)+v(3,i1+1,1)
         pup(4,i11)=v(0,i1,1)+v(0,i1+1,1)
c...invariant mass of vector boson(s)
         pup(5,i11)=dsqrt(pup(4,i11)**2-pup(3,i11)**2
     &        -pup(2,i11)**2-pup(1,i11)**2)
      enddo

      do i1=1,nup
         write(31),idup(i1),istup(i1),mothup(1,i1),
     &        mothup(2,i1),icolup(1,i1),icolup(2,i1), 
     &        pup(1,i1),pup(2,i1),pup(3,i1),pup(4,i1),
     &        pup(5,i1),vtimup(i1),spinup(i1)
      enddo
  
      end
      
c------------------------------------------------------------------------------

      subroutine kf_leptons(idflav)

      implicit double precision (a-h,o-z)
      implicit integer (i-n)

      include 'global.inc'

      integer idflav(4),i1
      double precision eprob,muprob,tauprob,rn,RandomNumber
      
      eprob=1.0d0/3
      muprob=2.0d0/3
      tauprob=3.0d0/3

      select case(procID)
      case(2103,103) 
         idflav(1)=-15
         idflav(2)= 15  
      case(2101,101) 
         idflav(1)= 22
         idflav(2)= 22   
      case(2104,104)
         idflav(1)= 5
         idflav(2)=-5
      case(2102,102)
         idflav(1)=-13
         idflav(2)= 13
      case(2111,111)
c...  W+ --> vl+ 
         idflav(1)= 12
         idflav(2)=-11
c...  W- -->v~l-
         idflav(3)=-12
         idflav(4)= 11
      case(2112,112)
c...  W+ --> vl+ 
         idflav(1)= 12
         idflav(2)=-11
c...  W- -->v~l-
         idflav(3)=-14
         idflav(4)= 13
      case(2113,113)
c...  W+ --> vl+ 
         idflav(1)= 12
         idflav(2)=-11
c...  W- -->v~l-
         idflav(3)=-16
         idflav(4)= 15
      case(2114,114)
c...  W+ --> vl+ 
         idflav(1)= 14
         idflav(2)=-13
c...  W- -->v~l-
         idflav(3)=-12
         idflav(4)= 11
      case(2115,115)
c...  W+ --> vl+ 
         idflav(1)= 14
         idflav(2)=-13
c...  W- -->v~l-
         idflav(3)=-14
         idflav(4)= 13
      case(2116,116)
c...W+ --> vl+ 
         idflav(1)= 14
         idflav(2)=-13
c...  W- -->v~l-
         idflav(3)=-16
         idflav(4)= 15
      case(2117,117)
c...  W+ --> vl+ 
         idflav(1)= 16
         idflav(2)=-15
c...  W- -->v~l-
         idflav(3)=-12
         idflav(4)= 11
      case(2118,118)
c...  W+ --> vl+ 
         idflav(1)= 16
         idflav(2)=-15
c...  W- -->v~l-
         idflav(3)=-14
         idflav(4)= 13
      case(2119,119)
c...  W+ --> vl+ 
         idflav(1)= 16
         idflav(2)=-15
c...  W- -->v~l-
         idflav(3)=-16
         idflav(4)= 15
      case(2141,141)
c...  Z --> l+l-
         idflav(1)=-11
         idflav(2)= 11
c...  Z --> l+l-
         idflav(3)=-13
         idflav(4)= 13
      case(2142,142)
c...  Z --> l+l-
         idflav(1)=-11
         idflav(2)= 11
c...  Z --> l+l-
         idflav(3)=-15
         idflav(4)= 15
      case(2143,143)
c...  Z --> l+l-
         idflav(1)=-13
         idflav(2)= 13
c...  Z --> l+l-
         idflav(3)=-15
         idflav(4)= 15
      case(2144,144)
c...  Z --> l+l-
         idflav(1)=-11
         idflav(2)= 11
c...  Z --> l+l-
         idflav(3)=-14
         idflav(4)= 14
      case(2145,145)
c...  Z --> l+l-
         idflav(1)=-13
         idflav(2)= 13
c...  Z --> l+l-
         idflav(3)=-14
         idflav(4)= 14
      case(2146,146)
c...  Z --> l+l-
         idflav(1)=-15
         idflav(2)= 15
c...  Z --> l+l-
         idflav(3)=-14
         idflav(4)= 14
      case(2201,201)
c...  Z --> l+l-
         idflav(1)=-11
         idflav(2)= 11
      case(2202,202)
c...  Z --> l+l-
         idflav(1)=-13
         idflav(2)= 13
      case(2203,203)
c...  Z --> l+l-
         idflav(1)=-15
         idflav(2)= 15
      case(2204,204)
c...  Z --> l+l-
         idflav(1)=-12
         idflav(2)= 12
      case(2301,301)
c...  W+ --> vl+ 
         idflav(1)= 12
         idflav(2)=-11 
      case(2302,302)
c...  W+ --> vl+ 
         idflav(1)= 14
         idflav(2)=-13  
      case(2303,303)
c...  W+ --> vl+ 
         idflav(1)= 16
         idflav(2)=-15  
      case(2304,304)
c...  W- --> v~l-
         idflav(1)=-12
         idflav(2)= 11
      case(2305,305)
c...  W- --> v~l-
         idflav(1)=-14
         idflav(2)= 13
      case(2306,306)
c...  W- --> v~l-
         idflav(1)=-16
         idflav(2)= 15
      case(2411,411)
c...  W+ --> vl+ 
         idflav(1)= 12
         idflav(2)=-11
c...  W- -->v~l-
         idflav(3)=-12
         idflav(4)= 11
      case(2412,412)
c...  W+ --> vl+ 
         idflav(1)= 12
         idflav(2)=-11
c...  W- -->v~l-
         idflav(3)=-14
         idflav(4)= 13
      case(2413,413)
c...  W+ --> vl+ 
         idflav(1)= 12
         idflav(2)=-11
c...  W- -->v~l-
         idflav(3)=-16
         idflav(4)= 15
      case(2414,414)
c...  W+ --> vl+ 
         idflav(1)= 14
         idflav(2)=-13
c...  W- -->v~l-
         idflav(3)=-12
         idflav(4)= 11
      case(2415,415)
c...  W+ --> vl+ 
         idflav(1)= 14
         idflav(2)=-13
c...  W- -->v~l-
         idflav(3)=-14
         idflav(4)= 13
      case(2416,416)
c...  W+ --> vl+ 
         idflav(1)= 14
         idflav(2)=-13
c...  W- -->v~l-
         idflav(3)=-16
         idflav(4)= 15
      case(2417,417)
c...  W+ --> vl+ 
         idflav(1)= 16
         idflav(2)=-15
c...  W- -->v~l-
         idflav(3)=-12
         idflav(4)= 11
      case(2418,418)
c...  W+ --> vl+ 
         idflav(1)= 16
         idflav(2)=-15
c...  W- -->v~l-
         idflav(3)=-14
         idflav(4)= 13
      case(2419,419)
c...  W+ --> vl+ 
         idflav(1)= 16
         idflav(2)=-15
c...  W- -->v~l-
         idflav(3)=-16
         idflav(4)= 15
      case(2501,501)
         idflav(1)=-11
         idflav(2)= 11
         idflav(3)=-13
         idflav(4)= 13
      case(2502,502)
         idflav(1)=-11
         idflav(2)= 11
         idflav(3)=-15
         idflav(4)= 15
      case(2503,503)
         idflav(1)=-13
         idflav(2)= 13
         idflav(3)=-15
         idflav(4)= 15
      case(2504,504)
         idflav(1)=-11
         idflav(2)= 11
         idflav(3)=-14
         idflav(4)= 14
      case(2505,505)
         idflav(1)=-13
         idflav(2)= 13
         idflav(3)=-14
         idflav(4)= 14
      case(2506,506)
         idflav(1)=-15
         idflav(2)= 15
         idflav(3)=-14
         idflav(4)= 14
      end select
      end
      
c------------------------------------------------------------------------------

      subroutine bostdq(idir,vv,pp,q)
      implicit double precision (a-h,o-z)
      implicit integer (i-n)

c------------------------------------------------------------------------------
c...boost along arbitrary vector vv
c...four-vector pp is boosted from an actual frame to the rest frame
c...of the four-vector vv (for idir=1) or back (for idir=-1)
c...q is a resulting four-vector
c...note: vv must be time-like, pp may be arbitrary
c------------------------------------------------------------------------------
      
      double precision v(4),p(4),q(4),pp(4),vv(4)
      integer i,idir
      double precision amv,wsp

      do i=1,4
         v(i)=vv(i)
         p(i)=pp(i)
      enddo

      amv=(v(4)**2-v(1)**2-v(2)**2-v(3)**2)
      if (amv.le.0d0) then
        print*,'bosstv: warning amv**2=',amv
      endif
      amv=dsqrt(abs(amv))
      if (idir.eq.-1) then
        q(4)=( p(1)*v(1)+p(2)*v(2)+p(3)*v(3)+p(4)*v(4))/amv
        wsp =(q(4)+p(4))/(v(4)+amv)
      elseif (idir.eq.1) then
        q(4)=(-p(1)*v(1)-p(2)*v(2)-p(3)*v(3)+p(4)*v(4))/amv
        wsp =-(q(4)+p(4))/(v(4)+amv)
      else
        print*,'boostv: wrong value of idir = ',idir
      endif

      q(1)=p(1)+wsp*v(1)
      q(2)=p(2)+wsp*v(2)
      q(3)=p(3)+wsp*v(3)

      end

c------------------------------------------------------------------------------

      subroutine fillColorless(idflav,listposition)

      implicit double precision (a-h,o-z)
      implicit integer (i-n)


      include 'global.inc'
      include 'lha.inc'

      integer i1,i11,iput
      integer idflav(4),listposition,id1,id2,id3,id4
      
      listposition=1

c...particle identity code
      select case(procID)
      case(2111:2119,111:119,2411:2419,411:419) !W+W-
         lidup(n_p+1,listposition)= 24
         lidup(n_p+2,listposition)=-24
      case(2501:2506,501:506,2141:2146,141:146)  !ZZ
         lidup(n_p+1,listposition)= 23
         lidup(n_p+2,listposition)= 23
      case(2100:2104,100:104) !H
         lidup(n_p+1,listposition)= 25
      case(2201:2204,201:204)   !Z
         lidup(n_p+1,listposition)= 23
      case(2301:2303,301:303)   !W+
         lidup(n_p+1,listposition)= 24 
      case(2304:2306,304:306)   !W-
         lidup(n_p+1,listposition)=-24 
      end select
 
      do i1=1,n_b
         i11=n_p+i1
c...colour information
         licolup(1,i11,listposition)=0
         licolup(2,i11,listposition)=0
         
c...orgin inforamtion of vector boson(s)
         lmothup(1,i11,listposition)=1
         lmothup(2,i11,listposition)=2
c...status code of particle (=-1 incoming particle =1 outgoing)
         listup(i11,listposition)=2
         select case(procID)
         case(2100,100)  
            listup(i11,listposition)=1
         end select
      enddo

      call kf_leptons(idflav)

      id1=idflav(1)
      id2=idflav(2)
      id3=idflav(3)
      id4=idflav(4)

      do i1=1,n_v
         i11=n_p+n_b+i1
         lidup(i11,listposition)=idflav(i1) 
         listup(i11,listposition)= 1
         licolup(1,i11,listposition)= 0
         licolup(2,i11,listposition)= 0
         if(idflav(i1).eq.5)then
            if(procID.eq.104)then
               licolup(1,i11,listposition)= 503
               licolup(2,i11,listposition)= 0
            elseif(procID.eq.2104)then
               licolup(1,i11,listposition)= 504
               licolup(2,i11,listposition)= 0
            endif
         elseif(idflav(i1).eq.-5) then
            if(procID.eq.104)then            
               licolup(1,i11,listposition)= 0
               licolup(2,i11,listposition)= 503               
            elseif(procID.eq.2104)then
               licolup(1,i11,listposition)= 0
               licolup(2,i11,listposition)= 504
            endif
         endif
      enddo   

      iput=0
      do i1=1,n_b*2,2
         iput=iput+1
         i11=n_p+n_b+i1
         lmothup(1,i11,listposition)=n_p+iput
         lmothup(2,i11,listposition)=0
         lmothup(1,i11+1,listposition)=n_p+iput
         lmothup(2,i11+1,listposition)=0
      enddo      

      end
