c
c--------- ptildemake(N,p,xuz) ----------------------------------
c
      subroutine VBFptildemake(N,p,xuz,v)
      implicit none
c
c assign ptilde momenta in notation of Catani&Seymour
c
c  input:  p(mu,1:np,1)      np parton momenta for real emission graph
c  output:                   np-1 parton momenta for Born amplitude
c          p(mu,1:np-1,2)        index=2: emission off 1-2 line
c          p(mu,1:np-1,3)        index=3: emission off 3-4 line
c
c          xuz(1,index)      x_ija etc
c          xuz(2,index)      u or z
c
c at the same time, fill the legoplot variables for the external momenta
c
c       Dieter Zeppenfeld, <dieter@pheno.physics.wisc.edu>
c       Initial version:  November 2002
c       Last modified: March 5, 2003
c 
      integer mu,a,i,j,N,ii,jj
      include 'global.inc'
      real*8 p(0:3,max_p,max_ptilde),xuz(2,2:3),v(0:3,max_v,max_vtilde), omx,pipj,pipa,pjpa
c
c fill legoplot variables for final state particles
      integer N1,npart,ic
      real*8 tpi
      parameter (N1=max_p-nx,tpi=2d0*3.141592653589793)
      REAL*8 Y,PT,PHI,PNJ
      COMMON /BLIPSO/ Y(N1), PT(N1), PHI(N1), PNJ(0:4)   ! LIPSN output 
      real*8 yp, pTp, phip, yv, pTv, phiv, yx, pTx, phix
      common /blegof/ yp(N1,3), pTp(N1,3), phip(N1,3),
     1                yv(max_v), pTv(max_v), phiv(max_v)
      logical ldebug
      parameter (ldebug=.false.)
c
c  fill legoplot variables for final state particles
      if (N.eq.1) then
         npart = N1-1
      else
         npart = N1
      endif
c  set superfluous variables to zero
      do ic = npart+1,N1
         do ii = 1,3
            yp(ic,ii) = 0
            pTp(ic,ii) = 0
            phip(ic,ii) = 0
            do mu = 0,3
               p(mu,nx+ic,ii) = 0
            enddo
         enddo
      enddo
      do ic = 1,npart
         yp(ic,1) = y(ic)
         pTp(ic,1) = PT(ic)
         phip(ic,1) = phi(ic)
         do ii = 2,3
            yp(ic,ii) = 0
            pTp(ic,ii) = 0
            phip(ic,ii) = 0
         enddo
         if (ldebug) then
            write(6,*) ' '
            call legoy(p(0,nx+ic,1),ptx,yx,phix)
            print*,' parton ',ic,', 1:',y(ic)/yx,pt(ic)/ptx,phi(ic)/phix
         endif
      enddo
      do ic = 1,n_v
         call legoy(v(0,ic,1),ptv(ic),yv(ic),phiv(ic))
      enddo
c  parton np is the potentially soft/collinear one
      do ii = 2,N
         if (ii.eq.2) then        ! set mom id for radiation off 1,2 line
            a = 1
            i = 5
            j = 3
         elseif (ii.eq.3) then
            a = 2
            i = 5
            j = 4
         else
            stop
         endif
         pipj = p(0,i,1)*p(0,j,1)-p(1,i,1)*p(1,j,1)-
     1          p(2,i,1)*p(2,j,1)-p(3,i,1)*p(3,j,1)
         pipa = p(0,i,1)*p(0,a,1)-p(1,i,1)*p(1,a,1)-
     1          p(2,i,1)*p(2,a,1)-p(3,i,1)*p(3,a,1)
         pjpa = p(0,j,1)*p(0,a,1)-p(1,j,1)*p(1,a,1)-
     1          p(2,j,1)*p(2,a,1)-p(3,j,1)*p(3,a,1)
         omx = pipj/(pipa+pjpa)
         xuz(1,ii) = 1d0 - omx
         xuz(2,ii) = pipa/(pipa+pjpa)
         if (ldebug) print*,' assign momenta # ',a,j,3-a,7-j
         do mu = 0,3
            p(mu,5,ii) = 0
            p(mu,a,ii) = xuz(1,ii)*p(mu,a,1)
            p(mu,j,ii) = p(mu,j,1)+p(mu,i,1)-omx*p(mu,a,1)
            p(mu,3-a,ii)=p(mu,3-a,1)
            p(mu,7-j,ii)=p(mu,7-j,1)
         enddo
c
c  fill legoplot variables for the ptilde
         call lego(p(0,j,ii),ptp(j-2,ii),yp(j-2,ii),phip(j-2,ii))
         pTp(5-j,ii) = pTp(5-j,1)
         yp(5-j,ii) = yp(5-j,1)
         phip(5-j,ii) = phip(5-j,1)

         if (ldebug) then
            do ic=1,npart-1
               call lego(p(0,ic+2,ii),ptx,yx,phix)
               print*,' parton ',ic,ii,' :',yp(ic,ii)/yx,ptp(ic,ii)/ptx,
     1                                      phip(ic,ii)/phix
            enddo
check momentum conservation
            do mu = 0,3
               omx = p(mu,n_p,1)
               do jj = 1,n_p-1
                  if(jj.le.2) omx = omx-p(mu,jj,1)+p(mu,jj,ii)
                  if(jj.gt.2) omx = omx+p(mu,jj,1)-p(mu,jj,ii)
               enddo
               print*,' mom.cons. for mu=',mu,': sum= ',omx
            enddo
check masslessness of ptilde_a and ptilde_j
            print*,' p_a^2 = ',p(0,a,ii)**2-p(1,a,ii)**2-
     1                         p(2,a,ii)**2-p(3,a,ii)**2
            print*,' p_j^2 = ',p(0,j,ii)**2-p(1,j,ii)**2-
     1                         p(2,j,ii)**2-p(3,j,ii)**2
         endif
      enddo
      if ( ldebug ) then
 10      format( ' p(', i1, ') = ', 4(f10.3, 2x) )
c
         do j = 1,N
            if (j.eq.1) print*,' (n+1) parton momenta '
            if (j.eq.2) print*,' n-parton momenta for upper NLO corr.'
            if (j.eq.3) print*,' n-parton momenta for lower NLO corr.'
            do i = 1, n_p-min(j-1,1)
               write(6,10) i, p(0,i,j), p(1,i,j), p(2,i,j), p(3,i,j)
            end do
            print*,' pT = ',(ptp(i,j),i=1,3-min(j-1,1))
            print*,' y  = ',(yp(i,j),i=1,3-min(j-1,1))
            print*,' phi= ',(phip(i,j),i=1,3-min(j-1,1))
         enddo
         print*, ' lepton pT = ',pTv
         print*, ' lepton y  = ',yv
         print*, ' lepton phi= ',phiv
      end if
      end
