      integer function FL4qcd(if1,if2,if3,if4,colstr)
c     Terrance Figy
c     June 12,2001
c     if1,2 are flavor identifiers for incoming partons
c     if3,4 are flavor identifiers for outgoing partons
c
c     However, note that colstruc is also a flag:
c     if colstr = -1, then we are resetting the process counter to 0
c
      Implicit none
      include '../../src/global.inc'
      include '../../src/lha.inc'
c     COMMOM BLOCK FOR DIAGRAMMATIC LABELS
      integer idq,idg
      common/diagram/ idq(1:4),idg(1:2)
c     This commom block must be in m2s.
c
c     common block for the number of colored processes

      integer i,if1,if2,if3,if4,colstr
      integer listp
      save listp
      integer numresets
      save numresets
c      integer,save :: listp ! this is the list position
c      integer,save :: numresets
      data numresets /-1/
      data listp /0/

      if (colstr.le.-1) then  ! we are resetting
c     write(*,*) 'in FL4 we are resetting'
         if (colstr.gt.-10000) then
            listp = -colstr
         else
            listp = 0
         endif
         numresets = numresets+1
      else
c increment the counter regardless of whether or not it's the 1st
c time throught
         listp = listp + 1
         if(numresets.eq.0) then
            call fillColoredPartons(if1,if2,if3,if4,colstr,listp)
         endif                  ! numresets.eq.0
      endif
      numcolor = listp ! common block info
      FL4qcd   = listp ! outputed function 
c     
      end
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     begin fillColoredPartons
c
c     the only processes here are the following:
c     4Q  2Q2G
c  
c     For 4Q there are 2 color structures.
c      
c    q2 ------------------------q1
c               9
c               6
c               9
c               6
c    q4 -----------------------q3
c            colstr=1
c   
c    q4 ------------------------q1
c               9
c               6
c               9
c               6
c    q2 -----------------------q3
c            colstr=2
c
           subroutine fillColoredPartons(if1,if2,if3,if4,colstr,listp1)
           implicit none
           include '../../src/global.inc'
           include '../../src/lha.inc'
           
c          COMMOM BLOCK FOR DIAGRAMMATIC LABELS
           integer idq,idg
           logical isCC ! is charge conj. state
           common/diagram/ idq(1:4),idg(1:2)
           integer i,if1,if2,if3,if4,colstr,listp1,listp
           integer ngluon,npart
           parameter (npart = 4)
           integer iflav(npart),p_i(1:2)
           integer col(1:2),cid(1:2)
c     cid is the color index, it 1 or 2
           listp = listp1 + numdecay
           lnup(listp) = numParticles 
c
c         lidprup(listposition)=listposition so we don't need to use it.
c         scalup is same for all subprocesses
c         lwgtup(listposition) is already stored in res(fl(....)) so
c         there's
c         no need to worry about it here.
c           write(*,*) 'writing to lhepup'
c
           
           listup(1,listp)=-1   !incoming quark or gluon
           listup(2,listp)=-1
           listup(3,listp)=1    !outgoin quark or gluon
           listup(4,listp)=1   

c
c         The particle codes:
          lidup(1,listp)=if1     
          lidup(2,listp)=if2
          lidup(3,listp)=if3
          lidup(4,listp)=if4

c         lSPINUP goes here:
c          do i = 1,4                   ! quarks and gluons are unpolarized
c             lspinup(i,listp) = 9      ! handle them in fillhepup.f
c          enddo
c
c         mothers:
          do i = 3,npart
             lmothup(1,i,listp) = 1
             lmothup(2,i,listp) = 2
          enddo
c
c     4Q and 2Q2G are the possibilities.
c     First, count the number of gluons to decide whether
c     4Q or 2Q2G.
          iflav(1) = if1
          iflav(2) = if2
          iflav(3) = if3
          iflav(4) = if4
          ngluon = 0
          do i = 1, npart
             if(iflav(i).eq.21) then 
                ngluon = ngluon + 1
             endif
          enddo
c
c          write(*,*) 'hello'
c     flip color and anticolor if charge conj. state
          isCC = ((idq(1).gt.2).and.(iflav(idq(1)).gt.0)).or.
     $         ((idq(1).lt.3).and.(iflav(idq(1)).lt.0))
          if(isCC) then
             cid(1) = 2
             cid(2) = 1
          else
             cid(1) = 1
             cid(2) = 2
          endif
c
          do i = 1,2
             col(i) = 0
          enddo
          if(ngluon.eq.0) then ! 4Q case             
             col(colstr) = 1 ! selects color structure
c
c
             if(idq(1).lt.3) then ! 1 and 2 are incoming pythia labels
                licolup(cid(1),idq(1),listp) = 501*col(1) +   
     $               501*col(2) ! color
                licolup(cid(2),idq(1),listp) = 0 ! anti-color 
             else
                licolup(cid(1),idq(1),listp) = 0 ! color
                licolup(cid(2),idq(1),listp) =  501*col(1) +   
     $               501*col(2) ! anti-color
             endif
c     
             if(idq(2).lt.3) then
                licolup(cid(1),idq(2),listp) = 0 ! color
                licolup(cid(2),idq(2),listp) = 502*col(1) +
     $               501*col(2) ! anti-color
             else
                licolup(cid(1),idq(2),listp) =502*col(1) +
     $               501*col(2) ! color
                licolup(cid(2),idq(2),listp) = 0 ! anti-color  
             endif
c     
             if(idq(3).lt.3) then
                licolup(cid(1),idq(3),listp) = 502*col(1) +
     $               502*col(2)  ! color
                licolup(cid(2),idq(3),listp) = 0 ! anti-color
             else
                licolup(cid(1),idq(3),listp) = 0 ! color
                licolup(cid(2),idq(3),listp) =  502*col(1) +
     $               502*col(2) ! anti-color  
             endif
c
             if(idq(4).lt.3) then
                licolup(cid(1),idq(4),listp) = 0 ! color
                licolup(cid(2),idq(4),listp) = 501*col(1) +
     $               502*col(2)   ! anti-color
             else
                licolup(cid(1),idq(4),listp) = 501*col(1) +
     $               502*col(2)  ! color
                licolup(cid(2),idq(4),listp) = 0 ! anti-color  
             endif
c 
c
          else  ! 2Q2G case
c     The next case goes here.
c
c     
c    q2 -----<----------------<-------q1 
c             0             0       
c             0             0       
c             0             0        
c           g_pi(1)       g_pi(2) 
c
c        pi = (1),(12)   See HZ
c    colstr =  1,   2      
c     
             select case(colstr)
             case(1)
                do i = 1,2
                   p_i(i) = i
                enddo
             case(2)
                p_i(1) = 2
                p_i(2) = 1
             endselect
c
             if(idq(1).lt.3) then  ! 1,2 are incoming
                licolup(cid(1),idq(1),listp) = 501 ! color
                licolup(cid(2),idq(1),listp) = 0 !anti-color
             else
                licolup(cid(1),idq(1),listp) = 0 ! color
                licolup(cid(2),idq(1),listp) = 501 !anti-color
             endif
c
             if(idq(2).lt.3) then  ! 1,2 are incoming
                licolup(cid(1),idq(2),listp) = 0 ! color
                licolup(cid(2),idq(2),listp) = 503 !anti-color
             else
                licolup(cid(1),idq(2),listp) = 503 ! color
                licolup(cid(2),idq(2),listp) = 0 !anti-color
             endif
c
             if(idg(p_i(1)).lt.3) then
                licolup(cid(1),idg(p_i(1)),listp) = 503 ! color
                licolup(cid(2),idg(p_i(1)),listp) = 502 !anti-color
             else
                licolup(cid(1),idg(p_i(1)),listp) = 502 ! color
                licolup(cid(2),idg(p_i(1)),listp) = 503 !anti-color
             endif
             if(idg(p_i(2)).lt.3) then
                licolup(cid(1),idg(p_i(2)),listp) = 502 ! color
                licolup(cid(2),idg(p_i(2)),listp) = 501 !anti-color
             else
                licolup(cid(1),idg(p_i(2)),listp) = 501 ! color
                licolup(cid(2),idg(p_i(2)),listp) = 502 !anti-color
             endif
c
          endif
          end ! fillColoredPartons
c
c
c$$$c
c$$$c*****************************************************************************
c$$$c
c$$$c    begin subroutine fillColorless
c$$$c
c$$$c*****************************************************************************
c$$$      subroutine fillColorless(id1,id2,PN)
c$$$c  assigns values to the variables in the common block localHEPUP
c$$$c  in particular, this subroutine assigns values to those variables that 
c$$$c  will be stored in the lookup tables generated by writeHEPUPtable.  
c$$$c  As the name suggests, this routine only stores the information for 
c$$$c  the uncolored particles.  Particles with color will be dealt with 
c$$$c  in the subroutine fillColoredPartons.  
c$$$
c$$$
c$$$      implicit none
c$$$    
c$$$      integer id1,id2           !flavor code of decay leptons
c$$$      integer PN                !which decay process we're dealing with. 
c$$$
c$$$      integer procnum
c$$$
c$$$      include '../global.inc'
c$$$      include '../lha.inc' 
c$$$
c$$$c  first, make sure we don't overwrite the color subprocesses.
c$$$
c$$$      procnum=pn
c$$$
c$$$      lnup(ProcNum) = numParticles
c$$$
c$$$      listup(6,ProcNum)=1
c$$$      listup(7,ProcNum)=1
c$$$
c$$$      lidup(6,ProcNum)=id1
c$$$      lidup(7,ProcNum)=id2     
c$$$
c$$$      lmothup(1,6,ProcNum)=5
c$$$      lmothup(2,6,ProcNum)=0
c$$$      lmothup(1,7,ProcNum)=5
c$$$      lmothup(2,7,ProcNum)=0
c$$$
c$$$      licolup(1,6,ProcNum)=0
c$$$      licolup(2,6,ProcNum)=0
c$$$      licolup(1,7,ProcNum)=0
c$$$      licolup(2,7,ProcNum)=0
c$$$      lspinup(6,ProcNum)=9          ! enter unpolarized leptons as default
c$$$      lspinup(7,ProcNum)=9          ! will be overwritten in m2s_z2j
c$$$
c$$$c  and now the intermediate boson
c$$$C      lidup(5,ProcNum)=23          ! is assigned in m2s_z2j
c$$$      listup(5,ProcNum)=2
c$$$      lmothup(1,5,ProcNum)=1
c$$$      lmothup(2,5,ProcNum)=2
c$$$      licolup(1,5,ProcNum)=0   
c$$$      licolup(2,5,ProcNum)=0   
c$$$      lspinup(5,ProcNum)=9
c$$$
c$$$      end
c$$$c****************************************************************************
c$$$c
c$$$c    end subroutine fillColorless
c$$$c
c$$$c****************************************************************************
